## ros-noetic-mrpt-graphslam-2d 0.1.15

=== CMakeLists.txt ===
# Catkin User Guide: http://www.ros.org/doc/groovy/api/catkin/html/user_guide/user_guide.html
# Catkin CMake Standard: http://www.ros.org/doc/groovy/api/catkin/html/user_guide/standards.html
cmake_minimum_required(VERSION 3.1)
project(mrpt_graphslam_2d)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  roscpp
  rospy
  std_msgs
  sensor_msgs
  geometry_msgs
  nav_msgs
  mrpt_msgs
  mrpt_msgs_bridge
  tf2
  tf2_ros
  tf2_geometry_msgs
  fkie_multimaster_msgs
  )
## System dependencies are found with CMake's conventions
find_package(mrpt-gui REQUIRED)
find_package(mrpt-graphslam REQUIRED)
find_package(mrpt-ros1bridge REQUIRED)

message(STATUS "MRPT_VERSION: ${MRPT_VERSION}")


if (CMAKE_COMPILER_IS_GNUCXX)
	# High level of warnings.
	# The -Wno-long-long is required in 64bit systems when including sytem headers.
	# The -Wno-variadic-macros was needed for Eigen3, StdVector.h
	add_compile_options(-Wall -Wno-long-long -Wno-variadic-macros)
	# Workaround: Eigen <3.4 produces *tons* of warnings in GCC >=6. See http://eigen.tuxfamily.org/bz/show_bug.cgi?id=1221
	if (NOT ${CMAKE_CXX_COMPILER_VERSION} LESS "6.0")
		add_compile_options(-Wno-ignored-attributes -Wno-int-in-bool-context)
	endif()
endif()

IF(CMAKE_COMPILER_IS_GNUCXX AND NOT CMAKE_BUILD_TYPE MATCHES "Debug")
  add_compile_options(-O3)
ENDIF()

################################################
## Declare ROS messages, services and actions ##
################################################

################################################
## Declare ROS dynamic reconfigure parameters ##
################################################

###################################
## catkin specific configuration ##
###################################

catkin_package(
#  INCLUDE_DIRS include
  #LIBRARIES mrpt_graphslam_2d
  CATKIN_DEPENDS
    roscpp
    rospy
    std_msgs
    sensor_msgs
    geometry_msgs
    nav_msgs
    mrpt_msgs
    mrpt_msgs_bridge
    tf2
    tf2_ros
    tf2_geometry_msgs
    fkie_multimaster_msgs
  #  DEPENDS system_lib
  )

###########
## Build ##
###########

## Specify additional locations of header files
## Your package locations should be listed before other locations
include_directories(
	include
  ${catkin_INCLUDE_DIRS}
	)

set(SR_GRAPHSLAM_SRC
  src/CConnectionManager.cpp
  src/common.cpp
  )

set(MR_GRAPHSLAM_MERGER_SRC
  src/CMapMerger.cpp
  src/TNeighborAgentMapProps.cpp
  )

add_library(${PROJECT_NAME}
  ${SR_GRAPHSLAM_SRC}
  )
add_executable(${PROJECT_NAME}_node
  ${SR_GRAPHSLAM_SRC}
  src/${PROJECT_NAME}_node.cpp
  )
add_executable(${PROJECT_NAME}_mr_node
  ${SR_GRAPHSLAM_SRC}
  src/${PROJECT_NAME}_mr_node.cpp
  )
add_executable(map_merger_node
  ${SR_GRAPHSLAM_SRC}
  ${MR_GRAPHSLAM_MERGER_SRC}
  src/map_merger_node.cpp
  )

## Specify libraries to link a library or executable target against
target_link_libraries(${PROJECT_NAME}
  mrpt::gui
  mrpt::graphslam
  mrpt::ros1bridge
  ${catkin_LIBRARIES}
  )
target_link_libraries(${PROJECT_NAME}_node
  mrpt::gui
  mrpt::graphslam
  mrpt::ros1bridge
  ${catkin_LIBRARIES}
  )
target_link_libraries(${PROJECT_NAME}_mr_node
  mrpt::gui
  mrpt::graphslam
  mrpt::ros1bridge
  ${catkin_LIBRARIES}
  )
target_link_libraries(map_merger_node
  mrpt::gui
  mrpt::graphslam
  mrpt::ros1bridge
  ${catkin_LIBRARIES}
  )

#############
## Install ##
#############

# Mark executables and/or libraries for installation
install(
  TARGETS ${PROJECT_NAME} ${PROJECT_NAME}_node ${PROJECT_NAME}_mr_node map_merger_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  )

# Mark other files for installation (e.g. launch and bag files, etc.)
install(DIRECTORY
  launch
  config
  rviz
  rosbags
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
  )

#############
## Testing ##
#############

## ros-noetic-mrpt-graphslam-2d 0.1.11

=== debian/changelog ===
ros-noetic-mrpt-graphslam-2d (0.1.11-1buster) buster; urgency=high

  * Ported to tf2 and mrpt::ros1bridge
  * Fix build with mrpt2
  * Update multimaster_msgs_fkie to fkie_ prefix
  * Merge branch 'master' of ssh://github.com/mrpt-ros-pkg/mrpt_slam
  * Update URLs to https
  * Update build dep to mrpt2
  * Merge pull request #65 <https://github.com/mrpt-ros-pkg/mrpt_slam/issues/65> from Pillowline/patch-1
    setting trajectory publishers to latched
  * setting trajectory publishers to latched
    So you can obtain data when running mrpt_graphslam with a bagfile, even after the playback has finished.
  * Contributors: Jose Luis Blanco-Claraco, Pillowline

 -- Nikos Koukis <nickkouk@gmail.com>  Thu, 23 Jun 2022 22:00:00 -0000

ros-noetic-mrpt-graphslam-2d (0.1.10-1buster) buster; urgency=high

  * fix build against current mrpt2
  * fix build against mrpt2
  * Contributors: Jose Luis Blanco Claraco, Jose Luis Blanco-Claraco

 -- Nikos Koukis <nickkouk@gmail.com>  Fri, 04 Oct 2019 22:00:00 -0000

ros-noetic-mrpt-graphslam-2d (0.1.9-1buster) buster; urgency=high

  * Fix build against MRPT 1.9.9
  * Switch header guards to pragma once
  * Contributors: Jose Luis Blanco-Claraco, Julian Lopez Velasquez, Vladislav Tananaev

 -- Nikos Koukis <nickkouk@gmail.com>  Sat, 13 Apr 2019 22:00:00 -0000

ros-noetic-mrpt-graphslam-2d (0.1.8-1buster) buster; urgency=high

  * Make catkin_lint clean
  * Contributors: Jose Luis Blanco Claraco

 -- Nikos Koukis <nickkouk@gmail.com>  Thu, 20 Sep 2018 22:00:00 -0000

ros-noetic-mrpt-graphslam-2d (0.1.7-1buster) buster; urgency=high

  * mrpt_graphslam_2d: Fix compilation warnings
  * Remove installation of the demo directory from mrpt_graphslam_2d.
    It doesn't exist, so causes problems at the last stage of cmake.
    Signed-off-by: Chris Lalancette <mailto:clalancette@openrobotics.org>
  * Contributors: Chris Lalancette, Jose Luis Blanco-Claraco, Nikos Koukis

 -- Nikos Koukis <nickkouk@gmail.com>  Wed, 19 Sep 2018 22:00:00 -0000

ros-noetic-mrpt-graphslam-2d (0.1.6-1buster) buster; urgency=high

  * Fixed compilation with MRPT 1.5
  * Merge pull request #41 <https://github.com/mrpt-ros-pkg/mrpt_slam/issues/41> from MaxGsomGsom/master
    Fixed build with mrpt 2.0
  * Fixed indents
  * Fixed build with mrpt 2.0
  * partial fix build w mrpt 2.0
  * fix build in mrpt 2.0
  * fix build; add optimized builds (-O3)
  * fix build against mrpt 1.5 series
  * Merge pull request #32 <https://github.com/mrpt-ros-pkg/mrpt_slam/issues/32> from bergercookie/master
    Correct prev_nodes_ICP error
  * Correct prev_nodes_ICP member var
  * mrpt_graphslam_2d: Add link to GitPitch slideshow
  * mrpt_graphslam_2d: Validate user args in rename_rviz_topics.py
  * use consistent cmake conventions for c++14
  * all but mrpt_graphslam_2d compiling against mrpt2.0
  * porting to mrpt2
  * fix #28 <https://github.com/mrpt-ros-pkg/mrpt_slam/issues/28>, compiling all nodes using -std=c++14
  * CMake finds MRPT >=1.5 in branch master
  * Merge pull request #23 <https://github.com/mrpt-ros-pkg/mrpt_slam/issues/23> from bergercookie/graphslam-devel
    mrpt_graphslam_2d:Add to ini config files, instructions
  * mrpt_graphslam_2d:Fix broken links in README
  * mrpt_graphslam_2d:Use template files and python script to generate rviz files for rosbag, gazebo runs
  * mrpt_graphslam_2d:Add to the instructions for running graphSLAM from rosbags
  * mrpt_graphslam_2d:Update graphslam_real_2.rviz file
  * mrpt_graphslam_2d:Tweak config for real-time usage
  * mrpt_graphslam_2d:Have .ini file specifically for gazebo simulations
  * mrpt_graphslam_2d:CGraphSlamEngine_MR to have its own struct for config variables
  * mrpt_graphslam_2d:Finish configuration for mr-slam with rosbags
  * mrpt_graphslam_2d:Add initial setup and instructions for running mr-slam from rosbags
  * mrpt_graphslam_2d:Correct sr_graphslam_demo_gt execution
  * mrpt-graphslam:Modify parameters of mr-slam .ini file
  * mrpt_graphslam:Add rviz file for 4 agents
  * mrpt-graphslam:Remove deprecated .ini argument
  * mrpt-graphslam_2d:Add using directives when needed
  * Merge pull request #22 <https://github.com/mrpt-ros-pkg/mrpt_slam/issues/22> from bergercookie/graphslam-devel
    Add support for 2D multi-robot SLAM
  * mrpt_graphslam_2d:Comply to MRPT changes
  * Comply to new MRPT_LOG_*_STREAM format
  * Update rviz files, launchfiles
  * mrpt_graphslam_2d: Correct error in visualization of robot orientation in rviz
  * mrpt_graphslam_2d: Publish current robot_position to topic
  * Update rviz file
  * mrpt_graphslam_2d: Visualize compressed versions of images
  * mrpt_graphslam_2d: Update documentation
  * mrpt_graphslam_2d: Add local .gitignore
  * mrpt_graphslam_2d: Skip first unecessary seconds of demo_short_loop rosbag
  * Fix bug when running with more than 2 agents
    Bug occurred due to a dangling reference after rewriting the contents of a
    vector
  * mrpt_graphslam_2d: Successful mr-graphslam real-time experiment
  * Add configuration file for real-time mr-graphSLAM
  * mrpt_graphslam_2d: Have topic_namespace of agent be the same as its name
  * mrpt_graphslam_2d: Add rest of nodes in batches
    Knowing the transformation from own graph to neighbor's graph I
    integrate into own map the rest of the received nodes in batches of X
    nodes (default=4)
  * Change names of files and classes *_CM -> *_MR
    Multi-robot SLAM is no longer (heavily) based on Condensed Measurements,
    thus the corresponding files/classes are named appropriately.
    MR: Multi-robot
  * mrpt_graphslam_2d: Finish first working version of mr-graphSLAM
  * mrpt-graphslam: Add more rviz files for gazebo
    Commit also temporarily deals with the segfault when running with more
    than 2 robots
  * Finish first working version of map_merger node
    map_merger node subscribes to all the published maps and trajectories,
    fetches the results and upon user request computes an appropriate


=== debian/control ===
Source: ros-noetic-mrpt-graphslam-2d
Section: misc
Priority: optional
Maintainer: Nikos Koukis <nickkouk@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-fkie-multimaster-msgs, ros-noetic-geometry-msgs, ros-noetic-mrpt-msgs, ros-noetic-mrpt-msgs-bridge, ros-noetic-mrpt2, ros-noetic-nav-msgs, ros-noetic-roscpp, ros-noetic-rospy, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-tf2, ros-noetic-tf2-geometry-msgs, ros-noetic-tf2-ros
Homepage: http://www.mrpt.org/
Standards-Version: 3.9.2

Package: ros-noetic-mrpt-graphslam-2d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-fkie-multimaster-msgs, ros-noetic-geometry-msgs, ros-noetic-mrpt-msgs, ros-noetic-mrpt-msgs-bridge, ros-noetic-mrpt2, ros-noetic-nav-msgs, ros-noetic-roscpp, ros-noetic-rospy, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-tf2, ros-noetic-tf2-geometry-msgs, ros-noetic-tf2-ros
Description: Implement graphSLAM using the mrpt-graphslam library, in an online fashion by directly reading measurements off ROS Topics.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-mrpt-graphslam-2d//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install

## ros-noetic-mrpt-graphslam-2d 0.1.15

=== debian/changelog ===
ros-noetic-mrpt-graphslam-2d (0.1.15-1focal) focal; urgency=high

  * Fix build errors and warnings with latest mrpt2 versions
    (Closes: #71 <https://github.com/mrpt-ros-pkg/mrpt_slam/issues/71>)
  * Contributors: Jose Luis Blanco-Claraco

 -- Nikos Koukis <nickkouk@gmail.com>  Tue, 01 Aug 2023 22:00:00 -0000

ros-noetic-mrpt-graphslam-2d (0.1.14-1focal) focal; urgency=high

  * 0.1.13
  * fix version
  * changelog
  * Fix build against last mrpt 2.7.x
  * chagelogs
  * Contributors: Jose Luis Blanco Claraco, Jose Luis Blanco-Claraco

 -- Nikos Koukis <nickkouk@gmail.com>  Tue, 11 Apr 2023 22:00:00 -0000

ros-noetic-mrpt-graphslam-2d (0.1.11-1focal) focal; urgency=high

  * Ported to tf2 and mrpt::ros1bridge
  * Fix build with mrpt2
  * Update multimaster_msgs_fkie to fkie_ prefix
  * Merge branch 'master' of ssh://github.com/mrpt-ros-pkg/mrpt_slam
  * Update URLs to https
  * Update build dep to mrpt2
  * Merge pull request #65 <https://github.com/mrpt-ros-pkg/mrpt_slam/issues/65> from Pillowline/patch-1
    setting trajectory publishers to latched
  * setting trajectory publishers to latched
    So you can obtain data when running mrpt_graphslam with a bagfile, even after the playback has finished.
  * Contributors: Jose Luis Blanco-Claraco, Pillowline

 -- Nikos Koukis <nickkouk@gmail.com>  Thu, 23 Jun 2022 22:00:00 -0000

ros-noetic-mrpt-graphslam-2d (0.1.10-1focal) focal; urgency=high

  * fix build against current mrpt2
  * fix build against mrpt2
  * Contributors: Jose Luis Blanco Claraco, Jose Luis Blanco-Claraco

 -- Nikos Koukis <nickkouk@gmail.com>  Fri, 04 Oct 2019 22:00:00 -0000

ros-noetic-mrpt-graphslam-2d (0.1.9-1focal) focal; urgency=high

  * Fix build against MRPT 1.9.9
  * Switch header guards to pragma once
  * Contributors: Jose Luis Blanco-Claraco, Julian Lopez Velasquez, Vladislav Tananaev

 -- Nikos Koukis <nickkouk@gmail.com>  Sat, 13 Apr 2019 22:00:00 -0000

ros-noetic-mrpt-graphslam-2d (0.1.8-1focal) focal; urgency=high

  * Make catkin_lint clean
  * Contributors: Jose Luis Blanco Claraco

 -- Nikos Koukis <nickkouk@gmail.com>  Thu, 20 Sep 2018 22:00:00 -0000

ros-noetic-mrpt-graphslam-2d (0.1.7-1focal) focal; urgency=high

  * mrpt_graphslam_2d: Fix compilation warnings
  * Remove installation of the demo directory from mrpt_graphslam_2d.
    It doesn't exist, so causes problems at the last stage of cmake.
    Signed-off-by: Chris Lalancette <mailto:clalancette@openrobotics.org>
  * Contributors: Chris Lalancette, Jose Luis Blanco-Claraco, Nikos Koukis

 -- Nikos Koukis <nickkouk@gmail.com>  Wed, 19 Sep 2018 22:00:00 -0000

ros-noetic-mrpt-graphslam-2d (0.1.6-1focal) focal; urgency=high

  * Fixed compilation with MRPT 1.5
  * Merge pull request #41 <https://github.com/mrpt-ros-pkg/mrpt_slam/issues/41> from MaxGsomGsom/master
    Fixed build with mrpt 2.0
  * Fixed indents
  * Fixed build with mrpt 2.0
  * partial fix build w mrpt 2.0
  * fix build in mrpt 2.0
  * fix build; add optimized builds (-O3)
  * fix build against mrpt 1.5 series
  * Merge pull request #32 <https://github.com/mrpt-ros-pkg/mrpt_slam/issues/32> from bergercookie/master
    Correct prev_nodes_ICP error
  * Correct prev_nodes_ICP member var
  * mrpt_graphslam_2d: Add link to GitPitch slideshow
  * mrpt_graphslam_2d: Validate user args in rename_rviz_topics.py
  * use consistent cmake conventions for c++14
  * all but mrpt_graphslam_2d compiling against mrpt2.0
  * porting to mrpt2
  * fix #28 <https://github.com/mrpt-ros-pkg/mrpt_slam/issues/28>, compiling all nodes using -std=c++14
  * CMake finds MRPT >=1.5 in branch master
  * Merge pull request #23 <https://github.com/mrpt-ros-pkg/mrpt_slam/issues/23> from bergercookie/graphslam-devel
    mrpt_graphslam_2d:Add to ini config files, instructions
  * mrpt_graphslam_2d:Fix broken links in README
  * mrpt_graphslam_2d:Use template files and python script to generate rviz files for rosbag, gazebo runs
  * mrpt_graphslam_2d:Add to the instructions for running graphSLAM from rosbags
  * mrpt_graphslam_2d:Update graphslam_real_2.rviz file
  * mrpt_graphslam_2d:Tweak config for real-time usage
  * mrpt_graphslam_2d:Have .ini file specifically for gazebo simulations
  * mrpt_graphslam_2d:CGraphSlamEngine_MR to have its own struct for config variables
  * mrpt_graphslam_2d:Finish configuration for mr-slam with rosbags
  * mrpt_graphslam_2d:Add initial setup and instructions for running mr-slam from rosbags
  * mrpt_graphslam_2d:Correct sr_graphslam_demo_gt execution
  * mrpt-graphslam:Modify parameters of mr-slam .ini file
  * mrpt_graphslam:Add rviz file for 4 agents
  * mrpt-graphslam:Remove deprecated .ini argument
  * mrpt-graphslam_2d:Add using directives when needed
  * Merge pull request #22 <https://github.com/mrpt-ros-pkg/mrpt_slam/issues/22> from bergercookie/graphslam-devel
    Add support for 2D multi-robot SLAM
  * mrpt_graphslam_2d:Comply to MRPT changes
  * Comply to new MRPT_LOG_*_STREAM format
  * Update rviz files, launchfiles
  * mrpt_graphslam_2d: Correct error in visualization of robot orientation in rviz
  * mrpt_graphslam_2d: Publish current robot_position to topic
  * Update rviz file
  * mrpt_graphslam_2d: Visualize compressed versions of images
  * mrpt_graphslam_2d: Update documentation
  * mrpt_graphslam_2d: Add local .gitignore
  * mrpt_graphslam_2d: Skip first unecessary seconds of demo_short_loop rosbag
  * Fix bug when running with more than 2 agents
    Bug occurred due to a dangling reference after rewriting the contents of a
    vector
  * mrpt_graphslam_2d: Successful mr-graphslam real-time experiment
  * Add configuration file for real-time mr-graphSLAM
  * mrpt_graphslam_2d: Have topic_namespace of agent be the same as its name
  * mrpt_graphslam_2d: Add rest of nodes in batches
    Knowing the transformation from own graph to neighbor's graph I
    integrate into own map the rest of the received nodes in batches of X
    nodes (default=4)
  * Change names of files and classes *_CM -> *_MR
